// baesed on the idear of an recurring pattern
// not required for the day 16 task

struct EnumeratedCycle {
    pattern: Vec<i64>,
    position: usize,
    iteration: usize,
}

impl EnumeratedCycle {
    fn new(pattern: Vec<i64>, start: usize) -> Self {
        Self {
            pattern,
            position: 0,
            iteration: start,
        }
    }
}

impl Iterator for EnumeratedCycle {
    type Item = (usize, i64);
    fn next(&mut self) -> Option<Self::Item> {
        let item = self.pattern.get(self.position)?;
        let iteration = self.iteration;
        self.position += 1;
        if self.position == self.pattern.len() {
            self.position = 0;
            self.iteration += 1;
        }
        Some((iteration, *item))
    }
}
